VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Mmedia"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'-----------------------------------------------------
'   Name    :   MMedia.cls
'   Author  :   Peter Wright, For BG2VB4 & BG2VB5
'
'   Notes   :    ,    
'           :        
'           :    ,    .
'-----------------------------------------------------

' -=-=-=-  -=-=-=-
' Filename         
' Length          ( )
' Position         
' Status           ( )
' Wait          True/False... VB    

' -=-=-=-  -=-=-=-=-
' mmOpen <Filename>      
' mmClose               
' mmPause                 
' mmStop               ,    
' mmSeek <Position>      
' mmPlay                

'-------------------------------------------------------------
' NOTES
' -----
'
' Open ,   .
' Pause      .
' Stop,         .
' Close,       
'--------------------------------------------------------------

Private sAlias As String        '  ,  
                                '    
                                ' 

Private sFilename As String     '    
Private nLength As Single       '     
Private nPosition As Single     '    
Private sStatus As String       '     
Private bWait As Boolean        '    VB,   
                                '    
                                ' .

'------------ API DECLARATIONS -------------
'note that this is all one code line:
Private Declare Function mciSendString Lib "winmm.dll" _
   Alias "mciSendStringA" (ByVal lpstrCommand As String, _
   ByVal lpstrReturnString As String, ByVal uReturnLength As Long, _
   ByVal hwndCallback As Long) As Long

Public Sub mmOpen(ByVal sTheFile As String)
Attribute mmOpen.VB_Description = "    ."

    '  ,   ,  mciSendString
    Dim nReturn As Long
    
    '   ,    
    Dim sType As String

    '    ,    ,
    '    
    If sAlias <> "" Then
        mmClose
    End If
    
    '      
    Select Case UCase$(Right$(sTheFile, 3))
       Case "WAV"
          sType = "Waveaudio"
       Case "AVI"
          sType = "AviVideo"
       Case "MID"
          sType = "Sequencer"
       Case Else
          '         
          Exit Sub
    End Select
    sAlias = Right$(sTheFile, 3) & Minute(Now)

    '       , ,  
    '   .     .
    '  :    ,  
    '    
    If InStr(sTheFile, " ") Then sTheFile = Chr(34) & sTheFile & Chr(34)
    nReturn = mciSendString("Open " & sTheFile & " ALIAS " & sAlias _
            & " TYPE " & sType & " wait", "", 0, 0)
End Sub

Public Sub mmClose()
Attribute mmClose.VB_Description = "  ."
    '       

    '  ,    
    '  mciSendString
    Dim nReturn As Long

    '     ,    
    If sAlias = "" Then Exit Sub
    
    nReturn = mciSendString("Close " & sAlias, "", 0, 0)
    sAlias = ""
    sFilename = ""
    
End Sub

Public Sub mmPause()
Attribute mmPause.VB_Description = "    ."
    '  

    '  ,    
    '  mciSendString
    Dim nReturn As Long
    
    '     ,    
    If sAlias = "" Then Exit Sub
    
    nReturn = mciSendString("Pause " & sAlias, "", 0, 0)

End Sub

Public Sub mmPlay()
Attribute mmPlay.VB_Description = "  ."
    '       

    '  ,    
    '  mciSendString
    Dim nReturn As Long
    
    '     ,    
    If sAlias = "" Then Exit Sub
    
    '   
    If bWait Then
        nReturn = mciSendString("Play " & sAlias & " wait", "", 0, 0)
    Else
        nReturn = mciSendString("Play " & sAlias, "", 0, 0)
    End If
End Sub

Public Sub mmStop()
Attribute mmStop.VB_Description = " ,   ."
    '  

    '  ,    
    ' mciSendString
    Dim nReturn As Long
    
    '     ,    
    If sAlias = "" Then Exit Sub
    
    nReturn = mciSendString("Stop " & sAlias, "", 0, 0)
    
End Sub

Public Sub mmSeek(ByVal nPosition As Single)
Attribute mmSeek.VB_Description = "    ."
    '      

    '  ,    
    '  mciSendString
    Dim nReturn As Long
    
    nReturn = mciSendString("Seek " & sAlias & " to " & nPosition, "", 0, 0)

End Sub

Property Get Filename() As String
Attribute Filename.VB_Description = "   ."
' ,   ,  
'        
    Filename = sFilename
End Property

Property Let Filename(ByVal sTheFile As String)
' ,      ,
'    .  ,  
'     ,   
' -   mmOpen 
   mmOpen sTheFile
End Property

Property Get Wait() As Boolean
Attribute Wait.VB_Description = "True/False . . .     ."
' ,      .
   Wait = bWait
End Property

Property Let Wait(bWaitValue As Boolean)
' ,      
   bWait = bWaitValue
End Property

Property Get Length() As Single
Attribute Length.VB_Description = "  ( )."
   ' ,      
   '   

   '  ,     mciSendString
   Dim nReturn As Long, nLength As Integer

   '  ,      mci  
   Dim sLength As String * 255
    
   '     , ,   0
   If sAlias = "" Then
      Length = 0
      Exit Property
   End If

  nReturn = mciSendString("Status " & sAlias & " length", sLength, 255, 0)
  nLength = InStr(sLength, Chr$(0))
  Length = Val(Left$(sLength, nLength - 1))
End Property

Property Let Position(ByVal nPosition As Single)
Attribute Position.VB_Description = "   ."
'      
    mmSeek nPosition
End Property

Property Get Position() As Single
   '      
    
   ' Declare a variable to hold the return value from mciSendString
   Dim nReturn As Integer, nLength As Integer
    
   ' Declare a variable to hold the position returned
   ' by the mci Status position command
   Dim sPosition As String * 255

   ' If there is no file currently opened then exit the subroutine
   If sAlias = "" Then Exit Property
    
   '    
   nReturn = mciSendString("Status " & sAlias & " position", sPosition, 255, 0)
   nLength = InStr(sPosition, Chr$(0))
   Position = Val(Left$(sPosition, nLength - 1))

End Property

Property Get Status() As String
Attribute Status.VB_Description = "   ( )."
   '    /   

   ' Declare a variable to hold the return value from mciSendString
   Dim nReturn As Integer, nLength As Integer
    
   ' Declare a variable to hold the return string from mciSendString
   Dim sStatus As String * 255
    
   ' If there is no file currently opened, then exit the subroutine
   If sAlias = "" Then Exit Property

   nReturn = mciSendString("Status " & sAlias & " mode", sStatus, 255, 0)
    
   nLength = InStr(sStatus, Chr$(0))
   Status = Left$(sStatus, nLength - 1)
    
End Property

